%%Financial mathematics
%Black Scholes formula for dividend and non dividend palying stock;
%This is a copy right of Krishna Prasad, IIT Delhi
%For further information email to kprasad.iitd@gmail.com or +919891370585
%This is the GUI version of my program Black_scholes_formula_simple 
%which will very help to learn  GUI in matlab 
%%Start of coding, Symbols have their usual meaning 
%% start of gui
% this function is generated through matlab GUI giude
function varargout = Black_Scholes_Formula_gui(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Black_Scholes_Formula_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @Black_Scholes_Formula_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


%% --- Executes just before Black_Scholes_Formula_gui is made visible.
function Black_Scholes_Formula_gui_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;

guidata(hObject, handles);


%% ...
function varargout = Black_Scholes_Formula_gui_OutputFcn(hObject, eventdata, handles) 

varargout{1} = handles.output;


%% --- Executes on selection change in popup_DOP.
function popup_DOP_Callback(hObject, eventdata, handles)

%% ....
function popup_DOP_CreateFcn(hObject, eventdata, handles)


if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%% ....
function pushbutton_DOP_Callback(hObject, eventdata, handles)
    s0      = str2double(get(handles.enter_S0,'String'));
    k       = str2double(get(handles.enter_K,'String'));
    r       = str2double(get(handles.enter_R,'String'));
    T       = str2double(get(handles.enter_T,'String'));
    sigma   = str2double(get(handles.enter_sigma,'String')); 
   dtime    = str2double(get(handles.Dividend_time,'String'));
   damount  = str2double(get(handles.Dividend_amount,'String'));
   sa       = s0-damount*exp(-r*dtime);
    d1 = (log(sa/k)+(r+sigma^2/2)*T)/(sigma*sqrt(T));
    d2 = d1 - sigma*sqrt(T);
    
    callorput = get(handles.popup_DOP,'String');
    val       = get(handles.popup_DOP,'value');
    switch callorput{val}
        case 'Call_Option'
            c0 = sa*normcdf(d1)-k*exp(-r*T)*normcdf(d2);
            c = num2str(c0);
            set(handles.ans_DOP,'String',c);
            guidata(hObject,handles);
        case 'Put_Option'
            %p0 = k*exp(-r*T)*normcdf(-d2)-s0*normcdf(-d1);
            c0 = sa*normcdf(d1)-k*exp(-r*T)*normcdf(d2);
            p0 = c0-sa+k*exp(-r*T);
            p = num2str(p0);
            set(handles.ans_DOP,'String',p);
            guidata(hObject,handles);

    end


%% Non Dividend formula start from here
function popup_NDOP_Callback(hObject, eventdata, handles)
 % Determine the selected data set.
         str = get(hObject, 'String');
         val = get(hObject,'Value');
         % Set current data to the selected data set.
         switch str{val}
            case 'Call_Option' % User selects Peaks.
                input = 'Call_Option';
            case 'Put_Option' % User selects Membrane.
                input = 'Put_Option';
         end
         guidata(hObject,handles);
%% ....
function popup_NDOP_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%  --- Executes on button press in pushbutton_NDOP.
function pushbutton_NDOP_Callback(hObject, eventdata, handles)
    
    s0      = str2double(get(handles.enter_S0,'String'));
    k       = str2double(get(handles.enter_K,'String'));
    r       = str2double(get(handles.enter_R,'String'));
    T       = str2double(get(handles.enter_T,'String'));
    sigma   = str2double(get(handles.enter_sigma,'String')); 
    
    d1 = (log(s0/k)+(r+sigma^2/2)*T)/(sigma*sqrt(T));
    d2 = d1 - sigma*sqrt(T);
    
    callorput = get(handles.popup_NDOP,'String');
    val       = get(handles.popup_NDOP,'value');
    switch callorput{val}
        case 'Call_Option'
            c0 = s0*normcdf(d1)-k*exp(-r*T)*normcdf(d2);
            c = num2str(c0);
            set(handles.ans_NDOP,'String',c);
            guidata(hObject,handles);
        case 'Put_Option'
            %p0 = k*exp(-r*T)*normcdf(-d2)-s0*normcdf(-d1);
            c0 = s0*normcdf(d1)-k*exp(-r*T)*normcdf(d2);
            p0 = c0-s0+k*exp(-r*T);
            p = num2str(p0);
            set(handles.ans_NDOP,'String',p);
            guidata(hObject,handles);

    end
    
%% ....
function enter_S0_Callback(hObject, eventdata, handles)
    input = str2double(get(hObject,'String'));
    if (isempty(input))
        set(hObject,'String',0);
    end
    guidata(hObject,handles);
%% ....
function enter_S0_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%% ....
function enter_K_Callback(hObject, eventdata, handles)
input = str2double(get(hObject,'String'));
if (isempty(input))
    set(hObject,'String',0);
end
guidata(hObject,handles);

%% ....
function enter_K_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%% ....
function enter_R_Callback(hObject, eventdata, handles)
input = str2double(get(hObject,'String'));
if (isempty(input))
    set(hObject,'String',0);
end
guidata(hObject,handles);

%% ....
function enter_R_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% ....
function enter_T_Callback(hObject, eventdata, handles)
input = str2double(get(hObject,'String'));
if (isempty(input))
    set(hObject,'String',0);
end
guidata(hObject,handles)

%% ....
function enter_T_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%% ....
function enter_sigma_Callback(hObject, eventdata, handles)
input = str2double(get(hObject,'String'));
if (isempty(input))
    set(hObject,'String',0);
end
guidata(hObject,handles);

%% ....
function enter_sigma_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% ....
function Dividend_time_Callback(hObject, eventdata, handles)
input = str2double(get(hObject,'String'));
if (isempty(input))
    set(hObject,'String',0);
end

%% ....
function Dividend_time_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%% ....
function Dividend_amount_Callback(hObject, eventdata, handles)
input = str2double(get(hObject,'String'));
if (isempty(input))
    set(hObject,'String',0);
end
guidata(hObject,handles)

%% ....
function Dividend_amount_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
